/* $Id: ciflicker.c,v 1.4 2009-09-06 21:50:12 chris Exp $
 *
 * "flicker" the screen ten times (using inline
 * assembly for fillscr())
 */

/* pointer to screen memory, segment #3 */
unsigned short *screen = (unsigned short *)0x3000000;

/* fill screen memory with "value" */
static int fillscr(unsigned short value)
{
    /* Scratch variables needed to assign the registers used
       by the inline assembly part. */
    unsigned short scratch0, scratch1;
    unsigned long scratch2, scratch3;

    __asm__ volatile ("ldl   %S3,%5         \n\t"
                      "ld    %H1,#0x2000-1  \n\t"
                      "ld    @%S3,%H4       \n\t"
                      "ldl   %S2,%S3        \n\t"
                      "inc   %I3,#2         \n\t"
                      "ldir  @%S3,@%S2,%H1  \n\t"
                      : "=r" (scratch0), "=r" (scratch1), "=r" (scratch2), "=r" (scratch3)
                      : "0" (value), "m" (screen)
                      : "memory" );
}

/* small busy loop delay routine */
static void delay(void)
{
    unsigned long i = 0x20000;

    while (i--)
        ;
}

int main(void)
{
    int i;

    for (i = 0; i < 10; i++) {
        fillscr(0);
        delay();
        fillscr(0xffff);
        delay();
    }
    return 0;
}
