/* $Id: dir.c,v 1.3 2009-08-22 18:19:14 chris Exp $
 *
 * dir.cmd -- display directory contents using
 *            PCOS system calls
 */

#include <stdio.h>
#include <string.h>
#include <sys/pcos.h>

char name_buf[32];  /* file name buffer */

int main(int argc, char **argv)
{
    int retval;
    int length;   /* length of found filename */
    int rlength;  /* length of filename/search mask */
    char *search_name;
    char *file_pointer;
    int drive;
    int search_mode = 1;  /* search from beginning */

    if (argc > 2) {
        printf("usage: dir <filemask>\n");
        return 1;
    }

    /* if no argument given, search the default drive;
     * with argument, parse the drive number and use
     * the remainder of the string for the file mask
     */
    if (argc == 2) {
        if (*(*(argv + 1) + 1) == ':') {
            drive = **(argv + 1) - '0';
            if (strlen(*(argv + 1)) > 2) {
                rlength = strlen(*(argv + 1)) - 2;
                search_name = *(argv + 1) + 2;
            }
            else {  /* something like "0:" */
                rlength = 0;
                search_name = NULL;
            }
        }
        else {  /* no drive specified */
            drive = -1;  /* search default drive */
            rlength = strlen(*(argv + 1));
            search_name = *(argv + 1);
        }
    }
    else {
        drive = -1;  /* search default drive */
        rlength = 0;
        search_name = NULL;
    }

    /* search for files */
    while (1) {
        length = rlength;
        file_pointer = name_buf;
        retval = _pcos_search(drive, search_mode, &length, &file_pointer, search_name);
        if (retval != PCOS_ERR_OK) break;
        search_mode = 0;   /* from now on search from the last file found */
        name_buf[length] = 0;  /* zero terminate name */
        printf("found %s\n", name_buf);
    }

    if (retval != PCOS_ERR_NOENT) {
        printf("_pcos_search returned error %d\n", retval);
        return 1;
    }

    return 0;
}
