! $Id: flicker.s,v 1.4 2009-06-03 21:06:39 chris Exp $
!
! "flicker" the screen ten times
!

	.z8001
	.text
	.even
	.globl	_start

! entered from PCOS (in fact, from the default program prologue)
_start:	pop	r0,@sp	! get # of command line args

! throw cmd line args from stack (see p.2-37 asm manual)
	clr     r2
	ld	r3,r0
	sll	r3,#2
	addl	sp,rr2

! now the program's guts:
	ldl	rr6,#0x03000000	! setup pointer to screen memory
				! screen memory is in segment #3
	ldk	r4,#10		! ten times

loop:	clr	r0		! fill with 0 (black)
	calr	fillscr
	calr	delay		! short delay
	dec	r0,#1		! fill with 255 (white)
	calr	fillscr
	calr	delay		! short delay
	djnz	r4,loop

	ret

! fill screen memory with value of rl0
fillscr:ld	r5,#0x2000-1	! screen memory (monochrome)
				! is 16k in size, count in words

	ld	@rr6,r0		! fill first word
	ldl	rr8,rr6
	inc	r7,#2		! rr8 points to 2nd word of
				! screen memory
	ldir	@rr6,@rr8,r5	! fill the complete memory
	ret

! small busy loop delay routine
delay:	ldl	rr8,#0x20000
deloop:	djnz	r7,deloop
	djnz	r8,deloop
	ret

	.end
