/* $Id: pinb2.c,v 1.2 2009-09-18 21:26:42 chris Exp $
 *
 * read a byte from a port and display it (using in() function)
 * (c) Copyright 2009 by Christian Groessler, chris@groessler.org
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <limits.h>

unsigned char in(unsigned int portaddr)
{
    unsigned char retval;

    __asm__ volatile (
        "inb %Q0,@%H1 \n\t" : "=r" (retval) : "r" (portaddr));

    return retval;
}

int main(int argc, char **argv)
{
    unsigned long portaddr;
    char *endptr;
    unsigned char value;

    if (argc != 2) {
        fprintf(stderr, "usage: pinb <port address>\n");
        return 1;
    }

    /* get port address */
    portaddr = strtoul(*(argv + 1), &endptr, 0);
    if (portaddr > 0xffff || *endptr) {
        fprintf(stderr, "invalid port address!\n");
        return 1;
    }

    printf("reading from port 0x%04lx (%lu)", portaddr, portaddr);
    if (! (portaddr & 1))
        printf("\t\tWARNING: even address!");
    printf("\n");

    value = in(portaddr);

    printf("Port value: 0x%02x  (%u)\n", value, value);

    return 0;
}

/* Local Variables: */
/* c-file-style: "cpg" */
/* c-basic-offset: 4 */
/* End: */
